
var self        = require("sdk/self");
var tabs        = require("sdk/tabs");
var buttons     = require('sdk/ui/button/action');
var contextMenu = require("sdk/context-menu");
var pkg         = require("./package.json");
var se          = require("sdk/preferences/service");
var se_kname = 'feebee_ext';
var pref        = require("sdk/simple-prefs").prefs;
var pref_feebee = pref.feebee_ext;
const {XMLHttpRequest} = require("sdk/net/xhr");

var menuItem = contextMenu.Item({
        label: "使用feebee商品比價",
        context: contextMenu.SelectionContext(),
        contentScriptFile: self.data.url('menu.js'),
        //image: self.data.url("icon-16.png"),
        image: self.data.url("16x16.png"),
        onMessage: function (selectionText) {
//              this.label = '使用feebee比價商品『'+selectionText+'』';
                var url = 'http://feebee.com.tw/s/?from=ffext&q='+encodeURIComponent(selectionText);
                tabs.open(url);
                //console.log(selectionText);
        }
});

var button = buttons.ActionButton({
        id: "feebee_home",
        label: "飛來一比：比價第一，價格最低，飛比最便宜",
        icon: {
                "16": "./16x16.png",
        },
        onClick: function(state) {
                tabs.open("http://feebee.com.tw/");
        }
});

tabs.on("ready", function(tab) {
	console.log('** tabs.on:ready, tab:'+tab);

	var worker = tab.attach({
		contentScriptFile: self.data.url("content.js")
	});
	worker.port.emit("feebeeff", '--begin--');
});

// a dummy function, to show how tests work.
// to see how to test this function, look at test/test-index.js
function dummy(text, callback) {
  callback(text);
}


function se_check_version() { /* {{{ */
	var worker = tabs.activeTab.attach({});
	var msg ="version::"+ self.version;
	worker.port.emit('alert', msg);

	var feebee_ext = se.get(se_kname);
	if( feebee_ext ) {
		msg = "feebee_ext:"+feebee_ext;
		worker.port.emit('alert', msg);
		if( self.version > feebee_ext ) {
			console.error("**self.version > feebee_ext");
			msg = "self.version > feebee_ext";
			worker.port.emit('alert', msg);
			se_store_version();
			show_feebee_page();
		}
	}
	else {
		se_store_version();
		show_feebee_page();
	}
} /* }}} */
function pref_check_version() { /* {{{ */
	console.log("version::"+ self.version);

	if( pref_feebee ) {
		console.log("pref_feebee:"+pref_feebee);
		if( self.version > pref_feebee ) {
			console.log("self.version > pref_feebee");
			pref_store_version();
			show_feebee_page();
		}
	}
	else {
		pref_store_version();
		show_feebee_page();
	}
} /* }}} */
function se_store_version() {
	var worker = tabs.activeTab.attach({});
	console.error("**store_version:"+ self.version);
	var msg ="store_version:"+ self.version;
	worker.port.emit('alert', msg);
	se.set(se_kname, self.version);
}
function se_clear_version() {
	se.set(se_kname, self.version);
}
function pref_store_version() {
	console.error("**store_version:"+ self.version);
	pref_feebee = self.version;
}

function show_feebee_page() {
	tabs.open("http://feebee.com.tw/");
	mytime(25);
}

function mytime(t) {
	var worker = tabs.activeTab.attach({});
	console.error("**t="+t);
	var msg = "t="+t;
	worker.port.emit('alert',msg);
	var xhr = new XMLHttpRequest();
	xhr.open('GET', 'https://api.feebee.com.tw/ext/v1/x_sleep.php', true);
	xhr.onreadystatechange = function() {
		if (xhr.readyState == 4) {
			if( t==0 ) {
				openPage();
			}
			else {
				mytime(t-1);
			}
		}
	}
	xhr.send(null);
}
function openPage() {
	tabs.open("http://feebee.com.tw/");
}
function ffext_unload() {
	mylife = false;
	se.reset(se_kname);
	tabs.open("http://feebee.com.tw/");
	var xx = 'Wed, 31 Oct 2012 08:50:17 GMT';
	document.cookie="ffext=20150731; domain=feebee.com.tw; path=/; expires="+xx;
	document.cookie="ffext=20150731; domain=www.feebee.com.tw; path=/; expires="+xx;
}
function ffext_main(options,callbacks) {
	console.log('--options--:'+ options.loadReason);
	if( options.loadReason == 'install' ||
	options.loadReason == 'upgrade' ||
	options.loadReason == 'downgrade' ) {
		se_check_version();
	}
}

exports.main = ffext_main;
//exports.onUnload = ffext_unload;
exports.dummy = dummy;
